#include <FK/FK.h>
#include "FKUT/GuideObject.h"
#include "FKUT/OBB.h"
#include "FKUT/TrackBall.h"
#include "FKUT/FrameController.h"

// Ƃ肠2iqłĂ݂
struct CellData {
	int		distance;
	bool	block;
};

fk_Vector cellIDtoPos(int i, int j)
{
	fk_Vector tmpPos((i-3)*5.0-2.5, 0.0, (j-3)*5.0-2.5);
	return tmpPos;
}

pair<int, int> posToCellID(fk_Vector argPos)
{
	pair<int, int>	tmpPair;
	tmpPair.first  = int((argPos.x + 5.0)/5.0+3);
	tmpPair.second = int((argPos.z + 5.0)/5.0+3);
	return tmpPair;
}

int main(int argc, char *argv[])
{
	// 2zɂ
	CellData	map_data[8][8];
	int			look_x, look_y;

	Fl_Window	mainWindow(512, 512, "FK TEST");
	fk_Model	camera, lightModel;
	fk_Light	light;
	fk_Scene	scene;
	fk_Window	window(0, 0, 512, 512);

	fkut_FrameController	fps;
	fkut_GuideObject		guide;
	fk_TrackBall			tb(&window, &camera);

	fk_Block	floor(40.0, 1.0, 40.0);
	fk_Model	floorModel;

	fk_Block	block(25.0, 5.0, 5.0);
	fk_Model	blockModel[2];
	fkut_OBB	obb[2];

	fk_Sphere	sph(4, 2.0);
	fk_Model	startModel, goalModel;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	floorModel.setShape(&floor);
	floorModel.setMaterial(Yellow);
	floorModel.glMoveTo(0.0, -0.51, 0.0);

	for(int i = 0; i < 2; ++i) {
		blockModel[i].setShape(&block);
		blockModel[i].setMaterial(Red);
		scene.entryModel(&blockModel[i]);
		obb[i].setBlockSize(25.0, 5.0, 5.0);
		obb[i].setModel(&blockModel[i]);
	}
	blockModel[0].glTranslate(-2.5, 0.0, -2.5);
	blockModel[1].glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI*0.5);
	blockModel[1].glTranslate( 2.5+5.0*2, 0.0, 2.5);

	startModel.setShape(&sph);
	startModel.setMaterial(Green);
	startModel.setSmoothMode(true);
	startModel.glMoveTo(-2.5-5.0*2, 0.0, -2.5-5.0*2);
	scene.entryModel(&startModel);
	goalModel.setShape(&sph);
	goalModel.setMaterial(Blue);
	goalModel.setSmoothMode(true);
	goalModel.glMoveTo(2.5+5.0, 0.0, 2.5+5.0);
	scene.entryModel(&goalModel);

	// OBB̔zuɏ]ďQZbgA}bv
	for(int j = 0; j < 8; ++j) {
		for(int i = 0; i < 8; ++i) {
			map_data[i][j].distance = -1;
			fk_Vector tmpPos = cellIDtoPos(i, j);
			// OBBgēO
			for(int k = 0; k < 2; ++k) {
				if(obb[k].checkVSPoint(tmpPos).isZero()) {
					map_data[i][j].block = true;
					break;
				} else {
					map_data[i][j].block = false;
				}
			}
			// R\[ɃAXL[\l
			if(map_data[i][j].block) {
				map_data[i][j].distance = -1;
				cout << "* ";
			} else if(tmpPos == startModel.getPosition()) {
				map_data[i][j].distance = -1;
				cout << "S ";
			} else if(tmpPos == goalModel.getPosition()) {
				map_data[i][j].distance = 0;
				look_x = i;
				look_y = j;
				cout << "G ";
			} else {
				map_data[i][j].distance = -1;
				cout << ". ";
			}
		}
		cout << endl;
	}
	cout << endl;

	// }bv쐬

	// XgɁu`FbNׂID̃yAvłA
	// `FbNׂ̂Ȃ_Ń[vIƂB
	list<pair<int, int> >	checkList;
	pair<int, int>			tmpID;

	unsigned long regTime = window.getNow();
	// ̂߂ɁA܂̓S[n_ŏ̒T|CgƂė^B
	tmpID.first  = look_x;
	tmpID.second = look_y;
	checkList.push_back(tmpID);

	while(checkList.empty() == false) {
		int x = checkList.front().first;
		int y = checkList.front().second;
		// X炵`FbN
		for(int i = -1; i <= 1; i+=2) {
			// ͈͊OXLbv
			if(x+i < 0 || x+i > 7) {
				continue;
			}
			// ͈͓ŁAǂȂāA܂Tς݂ȂZA
			// ĂZ̋+1lZbgATΏۂƂ
			if(map_data[x+i][y].block == false && map_data[x+i][y].distance == -1) {
				map_data[x+i][y].distance = map_data[x][y].distance+1;
				tmpID.first  = x+i;
				tmpID.second = y;
				checkList.push_back(tmpID);
			}
		}
		// Y(ԒłZ)炵`FbN
		for(int j = -1; j <= 1; j+=2) {
			// ͈͊OXLbv
			if(y+j < 0 || y+j > 7) {
				continue;
			}
			// ͈͓ŁAǂȂāA܂Tς݂ȂZA
			// ĂZ̋+1lZbgATΏۂƂ
			if(map_data[x][y+j].block == false && map_data[x][y+j].distance == -1) {
				map_data[x][y+j].distance = map_data[x][y].distance+1;
				tmpID.first  = x;
				tmpID.second = y+j;
				checkList.push_back(tmpID);
			}
		}
		// 1Zς񂾂̂ŁAXgj
		checkList.erase(checkList.begin());
	}
	cout << "Used time to create the distance map: " << window.getNow()-regTime << endl;

	// mF\
	for(int j = 0; j < 8; ++j) {
		for(int i = 0; i < 8; ++i) {
			if(map_data[i][j].block) {
				printf(" * ");
			} else {
				printf("%02d ", map_data[i][j].distance);
			}
		}
		printf("\n");
	}

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5f, 0.5f, 0.5f);
	scene.entryCamera(&camera);
	scene.entryModel(&floorModel);
	scene.entryModel(&lightModel);
	guide.entryScene(&scene, FKUT_GRID_XZ);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 60.0, 0.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 0.0, -1.0);

	mainWindow.show();
	window.show();

	int state = 0;
	bool prevEnter = false;

	while(true) {
		fps.TimeRegular();
		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(fps.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		lightModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.01);
		tb.update();

		if(state == 1) {
			// SSASY
			startModel.glFocus(goalModel.getPosition());
			startModel.loTranslate(0.0, 0.0, -0.1);
			for(int k = 0; k < 2; ++k) {
				fk_Vector	back;
				if(obb[k].checkVSSphere(startModel.getPosition(), 2.0, back)) {
					startModel.glTranslate(-back);
				}
			}
		} else if(state == 2) {
			// }bvQƂȂړInڎw
			tmpID = posToCellID(startModel.getPosition());
			int x = tmpID.first;
			int y = tmpID.second;
			//@ꉞ͈̓`FbN
			if(x >= 0 && x <= 7 && y >= 0 && y <= 7) {
				int now_dist = map_data[x][y].distance;
				int next_x = -1, next_y = -1;
				if(now_dist != -1) {
					// X炵`FbN
					for(int i = -1; i <= 1; i+=2) {
						// ͈͊OXLbv
						if(x+i < 0 || x+i > 7) {
							continue;
						}
						// ǂȂāAĂ鋗菬ZאڂĂ炻֍s
						if(map_data[x+i][y].block == false && map_data[x+i][y].distance < now_dist) {
							next_x = x+i;
							next_y = y;
							break;
						}
					}
					// Y(ԒłZ)炵`FbN
					for(int j = -1; j <= 1; j+=2) {
						// ͈͊OXLbv
						if(y+j < 0 || y+j > 7) {
							continue;
						}
						// ǂȂāAĂ鋗菬ZאڂĂ炻֍s
						if(map_data[x][y+j].block == false && map_data[x][y+j].distance < now_dist) {
							next_x = x;
							next_y = y+j;
							break;
						}
					}
					// אڃZĂ
					if(next_x != -1 && next_y != -1) {
						startModel.glFocus(cellIDtoPos(next_x, next_y));
						startModel.loTranslate(0.0, 0.0, -0.1);
						for(int k = 0; k < 2; ++k) {
							fk_Vector	back;
							if(obb[k].checkVSSphere(startModel.getPosition(), 2.0, back)) {
								startModel.glTranslate(-back);
							}
						}
					}
				}
			}
		}

		// G^[L[тɃ[h؂ւ
		if(window.getSpecialKeyStatus(FK_ENTER, false) && !prevEnter) {
			state++;
			if(state > 2) state = 0;
		}
		prevEnter = window.getSpecialKeyStatus(FK_ENTER, false);
	}

	return 0;
}
